=== debian/changelog ===
obs-advanced-scene-switcher (1.32.8-1) unstable; urgency=medium

  * New upstream version 1.32.8.
  * debian/control:
      - Bumped Standards-Version to 4.7.3.
      - Removed no longer needed "Priority: optional" field.
      - Removed no longer needed "Rules-Requires-Root: no" field.
      - Updated dependencies to require libobs-dev and obs-studio >= 32.
        (Closes: #1128465)
  * debian/copyright: updated upstream and packaging copyright years.
  * debian/rules: added override for blhc to ignore CMake ABI tests.
  * debian/watch: migrated to version 5.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 23 Feb 2026 21:18:38 -0300
