=== debian/watch ===
Version: 5

Template: Github
Owner: WarmUpTill
Project: SceneSwitcher
